using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using BearWare;

namespace TeamTalk.NET
{
    public partial class LoginDlg : Form
    {
        TeamTalk4 ttclient;
        Settings settings;
        int login_cmdid = 0;

        public LoginDlg(TeamTalk4 tt, Settings settings)
        {
            ttclient = tt;
            this.settings = settings;
            InitializeComponent();

            nickTextBox.Text = settings.nickname;
            srvpasswdTextBox.Text = settings.server.srvpasswd;
            usernameTextBox.Text = settings.server.username;
            passwdTextBox.Text = settings.server.password;

            ttclient.OnCmdProcessing += new TeamTalk4.CommandProcessing(ttclient_OnCmdProcessing);
            ttclient.OnCmdError += new TeamTalk4.CommandError(ttclient_OnCmdError);
        }

        void ttclient_OnCmdError(ClientError nErrorNo, int nCmdID)
        {
            if (nCmdID == login_cmdid)
            {
                login_cmdid = 0; //reset cmdid
                button1.Enabled = true;
                nickTextBox.Enabled = true;
                srvpasswdTextBox.Enabled = true;
                usernameTextBox.Enabled = true;
                passwdTextBox.Enabled = true;

                switch (nErrorNo)
                {
                    case ClientError.CMDERR_INCORRECT_SERVER_PASSWORD:
                        MessageBox.Show("Invalid server password");
                        break;
                    case ClientError.CMDERR_INVALID_ACCOUNT:
                        MessageBox.Show("Invalid username or password");
                        break;
                    default :
                        MessageBox.Show("Unknown error occured: " + nErrorNo.ToString());
                        break;
                }
            }
        }

        void ttclient_OnCmdProcessing(int nCmdID, bool bComplete)
        {
            if (bComplete && nCmdID == login_cmdid)
                this.Close();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            settings.nickname = nickTextBox.Text;
            settings.server.srvpasswd = srvpasswdTextBox.Text;
            settings.server.username = usernameTextBox.Text;
            settings.server.password = passwdTextBox.Text;

            login_cmdid = ttclient.DoLogin(nickTextBox.Text, srvpasswdTextBox.Text,
                                     usernameTextBox.Text, passwdTextBox.Text);
            button1.Enabled = false;
            nickTextBox.Enabled = false;
            srvpasswdTextBox.Enabled = false;
            usernameTextBox.Enabled = false;
            passwdTextBox.Enabled = false;
        }

        private void button2_Click(object sender, EventArgs e)
        {
            ttclient.DoQuit();
        }

        private void LoginDlg_Load(object sender, EventArgs e)
        {
            this.CenterToScreen();
        }
    }
}